Page MenuHomePhabricator

Issues in Sandboxed Gadgets
Closed, ResolvedPublic

Description

  1. Entry Focus doesn't work in popups with unless you tab immediately to the entry as soon as the popup opens. If you miss on that or click first, you are out of luck in ever being able to type in the entry.
  1. Popups,tooltips,etc... (basically any extra windows that sandbox manages) don't seem to delete and clean their objects correctly and that has lead to at least two different crashes I've seen, primarily when artifacts are left from popup destroy and you try to restart or when popups destroy incorrectly:

https://pastebin.com/xcqxsWX6
https://pastebin.com/N21JjGCD

  1. Tooltips in window mode don't size correctly
  1. there needs to be a gadget_configure smart callback that happens when the settings menu item is clicked.
  1. there needs to be a gadget_removed smart callback that happens the user removes the gadget so that section of the config can be removed before the id is reused.

Basically a large part of what Marcel and I have seen, noted, and complained about with popups could be fixed with the addition of handling multiple ctxpopups at a time instead of only handling one, inst->ctxpopup.

That still leaves focus issues that would relate to the entries, and scrolling, and etc..., etc... but would fix the popup craziness wrt to crashing, showing, disappearing, etc

@bu5hm4n Perhaps you would like to list your issues here as well so we can keep them in one ticket?

Related Objects

My problems are:

  • Scrolling in the popup is working stutteringly
  • Entry in the gadget itself needs to be clicked like a million times to get focus into it.

Going to upload my code in a bit :)

This comment was removed by stephenmhouston.
This comment was removed by stephenmhouston.
This comment was removed by stephenmhouston.
This comment was removed by stephenmhouston.
stephenmhouston renamed this task from Issues in Sandboxed Gadgets (Primarily with Popups) to Issues in Sandboxed Gadgets.
stephenmhouston updated the task description. (Show Details)
zmike moved this task from Backlog to Active on the enlightenment_gadgets board.Jan 9 2018, 10:55 AM

It would be great to have a 100% repro case for popup artifacts

try this please.

Add slideshow gadget to desktop
open settings and click immediately outside the settings to dismiss
if the fileselector is still loading files, the popup is dismissed, but artifacts are left on desktop

if you wait until the fileselector is finished, all works fine

hope it helps.

zmike added a comment.Jan 10 2018, 9:26 AM

The above case seems more like a gadget bug than an infrastructure bug

try this please.

Add slideshow gadget to desktop
open settings and click immediately outside the settings to dismiss
if the fileselector is still loading files, the popup is dismissed, but artifacts are left on desktop

if you wait until the fileselector is finished, all works fine

hope it helps.

This stinks of a fileselector bug.

@zmike the artifacts were prominent at the time with wiked iirc. @bu5hm4n ?

This is a combination of bugs. The gadget must delete the child window as soon as the window is unfocused, as in the reference gadget https://git.enlightenment.org/enlightenment/modules/desksanity.git/tree/loader/test.c#n19. The docs should probably make this clear if it isn't already stated somewhere.

In T6443#109182, @zmike wrote:

This is a combination of bugs. The gadget must delete the child window as soon as the window is unfocused, as in the reference gadget https://git.enlightenment.org/enlightenment/modules/desksanity.git/tree/loader/test.c#n19. The docs should probably make this clear if it isn't already stated somewhere.

What is this a fix to?

Gadgets which fail to delete windows on unfocus

stephenmhouston closed this task as Resolved.Feb 13 2018, 9:43 AM
stephenmhouston triaged this task as Normal priority.